#version 330 core

uniform sampler2D textureMap;
uniform sampler2D textureMap2;

uniform mat4 viewProjectionInverse;
uniform mat4 viewProjectionPrevious;
uniform float blurScale;
uniform int blurSamples;

in vec2 uv;

out vec4 colorOut;

//vec4 fxaa(void)
//{
//	/*
//	 * Adapted from:
//	 * http://code.google.com/p/processing/source/browse/trunk/processing/java/libraries/opengl/examples/Shaders/FXAA/data/fxaa.glsl?spec=svn9724&r=9668
//	 */

//	vec4 retVal;

//	// The parameters are hardcoded for now, but could be
//	// made into uniforms to control from the program.
//	float FXAA_SPAN_MAX = 8.0;
//	float FXAA_REDUCE_MUL = 1.0/8.0;
//	//float FXAA_REDUCE_MUL = 0;
//	float FXAA_REDUCE_MIN = 1.0/128.0;
//	//vec2 texcoordOffset = vec2(1.0/1024.0, 1.0/768); // The inverse of the texture dimensions along X and Y (war vorher uniform)
//	vec2 texcoordOffset = 1.0 / textureSize(textureMap, 0);

//	vec3 rgbNW = textureOffset(textureMap, uv.xy, ivec2(-1, -1)).xyz;
//	vec3 rgbNE = textureOffset(textureMap, uv.xy, ivec2(+1, -1)).xyz;
//	vec3 rgbSW = textureOffset(textureMap, uv.xy, ivec2(-1, +1)).xyz;
//	vec3 rgbSE = textureOffset(textureMap, uv.xy, ivec2(+1, +1)).xyz;
//	vec3 rgbM = texture2D(textureMap, uv.xy).xyz;

//	vec3 luma = vec3(0.299, 0.587, 0.114);
//	float lumaNW = dot(rgbNW, luma);
//	float lumaNE = dot(rgbNE, luma);
//	float lumaSW = dot(rgbSW, luma);
//	float lumaSE = dot(rgbSE, luma);
//	float lumaM  = dot(rgbM , luma);

//	float lumaMin = min(lumaM, min(min(lumaNW, lumaNE), min(lumaSW, lumaSE)));
//	float lumaMax = max(lumaM, max(max(lumaNW, lumaNE), max(lumaSW, lumaSE)));

//	vec2 dir;
//	dir.x = -((lumaNW + lumaNE) - (lumaSW + lumaSE));
//	dir.y =  ((lumaNW + lumaSW) - (lumaNE + lumaSE));

//	float dirReduce = max((lumaNW + lumaNE + lumaSW + lumaSE) * (0.25 * FXAA_REDUCE_MUL), FXAA_REDUCE_MIN);

//	float rcpDirMin = 1.0/(min(abs(dir.x), abs(dir.y)) + dirReduce);

//	dir =	min(vec2(FXAA_SPAN_MAX, FXAA_SPAN_MAX),
//			max(vec2(-FXAA_SPAN_MAX, -FXAA_SPAN_MAX), dir * rcpDirMin)) * texcoordOffset;

//	vec3 rgbA = (1.0/2.0) * (
//		texture2D(textureMap, uv.xy + dir * (1.0/3.0 - 0.5)).xyz +
//		texture2D(textureMap, uv.xy + dir * (2.0/3.0 - 0.5)).xyz);
//	vec3 rgbB = rgbA * (1.0/2.0) + (1.0/4.0) * (
//		texture2D(textureMap, uv.xy + dir * (0.0/3.0 - 0.5)).xyz +
//		texture2D(textureMap, uv.xy + dir * (3.0/3.0 - 0.5)).xyz);
//	float lumaB = dot(rgbB, luma);

//	if((lumaB < lumaMin) || (lumaB > lumaMax)){
//		retVal.xyz=rgbA;
//	} else {
//		retVal.xyz=rgbB;
//	}
//	retVal.a = 1.0;
	
//	return retVal;
//}

//vec4 motionBlurGPUGems(void)
//{
//	/*
//	 * Adapted from:
//	 * http://http.developer.nvidia.com/GPUGems3/gpugems3_ch27.html
//	 */

//	// Get the depth buffer value at this pixel.  
//	float zOverW = texture(textureMap2, uv).r;  

//	// H is the viewport position at this pixel in the range -1 to 1.  
//	//vec4 H = vec4(uv.x * 2 - 1, (1 - uv.y) * 2 - 1,  zOverW, 1);
//	vec4 H = vec4(uv.x * 2 - 1, uv.y * 2 - 1,  zOverW, 1);

//	// Transform by the view-projection inverse.  
//	vec4 D = viewProjectionInverse * H;
//	// Divide by w to get the world position.  
//	vec4 worldPos = D / D.w;

//	// Current viewport position  
//	vec4 currentPos = H;  
//	// Use the world position, and transform by the previous view-projection matrix.  
//	vec4 previousPos = viewProjectionPrevious * worldPos;
//	// Convert to nonhomogeneous points [-1,1] by dividing by w.  
//	previousPos /= previousPos.w;  
//	// Use this frame's position and last frame's to compute the pixel velocity.  
//	vec2 velocity = (currentPos.xy - previousPos.xy) / 2.0;
//	velocity *= blurScale;

//	// Get the initial color at this pixel.
//	vec2 texCoord = uv;
//	vec4 color = texture(textureMap, texCoord);  
//	texCoord += velocity;  
//	for(int i = 1; i < blurSamples; ++i, texCoord += velocity)  
//	{  
//		// Sample the color buffer along the velocity vector.  
//		vec4 currentColor = texture(textureMap, texCoord);  
//		// Add the current color to our color sum.  
//		color += currentColor;  
//	}  
//	// Average all of the samples to get the final blur color.  
//	vec4 finalColor = color / blurSamples;  
//	return finalColor;
//}

vec4 motionBlurChapman(void)
{
	/*
	 * Adapted from:
	 * http://john-chapman-graphics.blogspot.co.at/2013/01/what-is-motion-blur-motion-pictures-are.html
	 * and
	 * http://http.developer.nvidia.com/GPUGems3/gpugems3_ch27.html
	 */

	// Get the depth buffer value at this pixel.  
	float zOverW = texture(textureMap2, uv).r;  

	// H is the viewport position at this pixel in the range -1 to 1.  
	//vec4 H = vec4(uv.x * 2 - 1, (1 - uv.y) * 2 - 1,  zOverW, 1);
	vec4 H = vec4(uv.x * 2 - 1, uv.y * 2 - 1,  zOverW, 1);

	// Transform by the view-projection inverse.  
	vec4 D = viewProjectionInverse * H;
	// Divide by w to get the world position.  
	vec4 worldPos = D / D.w;

	// Current viewport position  
	vec4 currentPos = H;  
	// Use the world position, and transform by the previous view-projection matrix.  
	vec4 previousPos = viewProjectionPrevious * worldPos;
	// Convert to nonhomogeneous points [-1,1] by dividing by w.  
	previousPos /= previousPos.w;

	previousPos.xy = previousPos.xy * 0.5 + 0.5;

	vec2 blurVec = previousPos.xy - uv;
	blurVec *= blurScale;

	// perform blur:
	vec4 result = texture(textureMap, uv);
	for (int i = 1; i < blurSamples; ++i) {
		// get offset in range [-0.5, 0.5]:
		vec2 offset = blurVec * (float(i) / float(blurSamples - 1) - 0.5);
  
		// sample & add to result:
		result += texture(textureMap, uv + offset);
	}
	result /= blurSamples;

	return result;
}

void main(void)
{
	colorOut = motionBlurChapman();

//	colorOut = motionBlurGPUGems();
//	colorOut = fxaa();
}
